use gdk_x11::{X11Surface, X11Display};
use gtk::{prelude::*, Application, ApplicationWindow, Label};
use std::process::exit;

fn main() {
    let app = Application::builder()
        .application_id("org.spurint.bscreensaver.dialog-gtk4")
        .build();
    app.connect_activate(build_ui);

    app.run();
}

fn build_ui(app: &Application) {
    let titlebar = Label::builder()
        .label("Unlock Screen")
        .halign(gtk::Align::Center)
        .single_line_mode(true)
        .build();
    titlebar.show();

    let window = ApplicationWindow::builder()
        .application(app)
        .titlebar(&titlebar)
        .modal(true)
        .decorated(false)
        .build();
    window.realize();

    let surface = unsafe { window.surface().unsafe_cast::<X11Surface>() };
    let xid = surface.xid();
    if xid == 0 {
        eprintln!("Lock dialog has no XID");
        exit(1);
    }
    println!("{}", surface.xid());

    let mut buf = String::new();
    let stdin = std::io::stdin();
    stdin.read_line(&mut buf).unwrap();

    window.present();
}
